<?php
namespace MR\Zip\Model\Api;

class ZipManagement implements \MR\Zip\Api\ZipManagementInterface
{
    // http://devdocs.magento.com/guides/v2.0/extension-dev-guide/service-contracts/service-to-web-service.html

    
    
    /**
     * 
     * @var \MR\Zip\Model\Api\ApiZipHelper
     */
    private $_apiHelper;

    /**
     *
     * @var \MR\Zip\Logger\ZipLogger
     */
    private $_logger;
    
    /**
     *
     * @var \Magento\Quote\Api\BillingAddressManagementInterface
     */
    private $_billingAddressManagement;


    public function __construct(\Magento\Quote\Api\BillingAddressManagementInterface $billingAddressManagement)
    {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $this->_billingAddressManagement = $billingAddressManagement;
        $this->_apiHelper = $objectManager->get("\MR\Zip\Model\Api\ApiZipHelper");
        $this->_logger = $objectManager->get("\MR\Zip\Logger\ZipLogger");
        
        $this->_logger->info(__METHOD__);
    }

    /**
     * {@inheritDoc}
     */
    public function set($cartId, \Magento\Quote\Api\Data\PaymentInterface $method, \Magento\Quote\Api\Data\AddressInterface $billingAddress = null)
    {
        $this->_logger->info(__METHOD__. " cartId:{$cartId}");
        
        if ($billingAddress) {
        	$this->_logger->info(__METHOD__. " assigning billing address");
        	$this->_billingAddressManagement->assign($cartId, $billingAddress);
        }
        
        $url = $this->_apiHelper->createUrlForCustomer($cartId, $method);
        $this->_logger->info(__METHOD__. " redirectUrl:{$url}");
        return $url;
    }

}
