<?php
namespace MR\Zip\Model;

use \Magento\Checkout\Model\ConfigProviderInterface;

// Invoked by Magento\Checkout\Block\Onepage::getCheckoutConfig
class ZipConfigProvider implements ConfigProviderInterface
{

    /**
     *
     * @var \MR\Zip\Logger\ZipLogger
     */
    private $_logger;

    /**
     *
     * @var \Magento\Framework\App\ObjectManager
     */
    private $_objectManager;

    /**
     *
     * @var \MR\Zip\Helper\Configuration
     */
    private $_configuration;

    public function __construct(\Magento\Framework\ObjectManagerInterface $objectManager)
    {
        $this->_objectManager = $objectManager;
        $this->_configuration = $this->_objectManager->get("\MR\Zip\Helper\Configuration");
        $this->_logger = $this->_objectManager->get("\MR\Zip\Logger\ZipLogger");
        $this->_logger->info(__METHOD__);
    }

    public function getConfig()
    {
        $this->_logger->info(__METHOD__);
        $session = $this->_objectManager->get('\Magento\Checkout\Model\Session');
        $quote = $session->getQuote();
        $quoteId = $quote->getId();
        
//        $customerSession = $this->_objectManager->get("\Magento\Customer\Model\Session");
        $paymentUtil = $this->_objectManager->get("\MR\Zip\Helper\PaymentUtil");

        
        return [
            'payment' => [
                'zip' => [
                    'redirectUrl' => $paymentUtil->buildRedirectUrl($quoteId),
                    'method' => \MR\Zip\Model\Payment::MR_ZIP_CODE
                ]
            ]
        ];
    }
}
